
% Exercicios de aula

% Exerccio 1: diferena simtrica
diferenca_simetrica(X,Y,Z) :-
	diferenca(X, Y, Z1),
	diferenca(Y, X, Z2),
	uniao(Z1, Z2, Z).

uniao([], L2, L2).
uniao([X|L1], L2, [X|L3]):- not(member(X, L2)),  uniao(L1, L2, L3).
uniao([X|L1], L2, L3):- member(X, L2),  uniao(L1, L2, L3).

naopertence(_, []).
naopertence(X,[B|Y]) :- not(X=B), naopertence(X,Y).

diferenca([],_,[]) :- !.
diferenca([X|Y], LR, L) :- member(X,LR), diferenca(Y,LR,L).
diferenca([X|Y], LR, [X|L]) :- \+member(X,LR), diferenca(Y,LR,L).


% Exerccio 2: multiplicao de nmeros pares ordenados

estaOrdenado([_|[]]) :-!.
estaOrdenado([X1,X2|T]):- X1 =< X2, !, estaOrdenado([X2|T]).

numerosPares([],[]).
numerosPares([Num|Cauda], [Num|Pares]) :- Num mod 2 =:= 0, !, numerosPares(Cauda, Pares).
numerosPares([_|Cauda],Pares) :- numerosPares(Cauda, Pares).

multiplica([N|[]],N).
multiplica([N|Cauda], Conta) :- multiplica(Cauda, Res), Conta is Res * N.

processo(ListaDeNumeros, Conta) :- estaOrdenado(ListaDeNumeros), 
				   numerosPares(ListaDeNumeros, NumerosPares), 
				   multiplica(NumerosPares, Conta).
                                 
% Exerccio 3: determinao de rede de contatos

conhece(joao, maria).
conhece(joao, jose).
conhece(maria, joaquim).
conhece(maria, pedro).
conhece(pedro, manuel).

rede(1, [P2|[P1|[]]]) :- !, conhecidos(P1, P2).
rede(N, [P2|[P1|C]]) :- N1 is N -1, conhecidos(P2, P1), rede(N1, [P1|C]), not(member(P2, [P1|C])).







